/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JPanel.java to edit this template
 */
package CustomerManagement;

import Service.CustomerService;
import java.awt.Font;
import java.text.MessageFormat;
import java.util.List;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.UIManager;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;
import model.Customer;

/**
 *
 * @author AlwaysLH
 */
public class CustomerPanel extends javax.swing.JPanel {

    private final CustomerService cusService;
    private List<Customer> customerList;
    private Customer editedCus;
    DefaultTableModel cusModel;

    /**
     * Creates new form CustomerPanel
     */
    public CustomerPanel() {
        initComponents();
        UIManager.put("OptionPane.messageFont", new Font("Tahoma", Font.PLAIN, 14));
        cusService = new CustomerService();
        customerList = cusService.getCustomers();
        cusModel = (DefaultTableModel) tblCustomer.getModel();
//        System.out.println(customerList);
        tblCustomer.setModel(new AbstractTableModel() {
            String[] columnNames = {"Customer ID", "Customer Name", "Customer Surname", "Customer Telephone", "Customer Points", "Number of Purchase", "Discount"};

            @Override
            public String getColumnName(int column) {
                return columnNames[column];
            }

            @Override
            public int getRowCount() {
                return customerList.size();
            }

            @Override
            public int getColumnCount() {
                return 7;
            }

            @Override
            public Object getValueAt(int rowIndex, int columnIndex) {
                Customer customer = customerList.get(rowIndex);
                switch (columnIndex) {
                    case 0:
                        return customer.getCusId();
                    case 1:
                        return customer.getCusName();
                    case 2:
                        return customer.getCusSurname();
                    case 3:
                        return customer.getCusTel();
                    case 4:
                        return customer.getCusPoint();
                    case 5:
                        return customer.getCusPurchaseCount();
                    case 6:
                        return customer.getCusDiscount();
                    default:
                        return "Unknowm";
                }
            }
        });

//        enableForm(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        scpPanel = new javax.swing.JScrollPane();
        pnlCustomer = new javax.swing.JPanel();
        txtSearch = new javax.swing.JTextField();
        btnSearch = new javax.swing.JButton();
        btnAddCustomer = new javax.swing.JButton();
        btnExport = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        tblCustomer = new javax.swing.JTable();

        scpPanel.setPreferredSize(new java.awt.Dimension(929, 556));

        pnlCustomer.setBackground(new java.awt.Color(245, 245, 245));

        txtSearch.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N

        btnSearch.setBackground(new java.awt.Color(172, 145, 118));
        btnSearch.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        btnSearch.setText("ค้นหา");
        btnSearch.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSearchActionPerformed(evt);
            }
        });

        btnAddCustomer.setBackground(new java.awt.Color(172, 145, 118));
        btnAddCustomer.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        btnAddCustomer.setText("เพิ่มลูกค้า");
        btnAddCustomer.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnAddCustomer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddCustomerActionPerformed(evt);
            }
        });

        btnExport.setBackground(new java.awt.Color(172, 145, 118));
        btnExport.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        btnExport.setText("Export");
        btnExport.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnExport.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnExportActionPerformed(evt);
            }
        });

        tblCustomer.setAutoCreateRowSorter(true);
        tblCustomer.setBackground(new java.awt.Color(211, 197, 186));
        tblCustomer.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        tblCustomer.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4", "Title 5", "Title 6", "Title 7"
            }
        ));
        tblCustomer.setRowHeight(40);
        tblCustomer.setShowGrid(true);
        jScrollPane2.setViewportView(tblCustomer);

        javax.swing.GroupLayout pnlCustomerLayout = new javax.swing.GroupLayout(pnlCustomer);
        pnlCustomer.setLayout(pnlCustomerLayout);
        pnlCustomerLayout.setHorizontalGroup(
            pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlCustomerLayout.createSequentialGroup()
                .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlCustomerLayout.createSequentialGroup()
                        .addGap(24, 24, 24)
                        .addComponent(txtSearch, javax.swing.GroupLayout.PREFERRED_SIZE, 290, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(btnSearch, javax.swing.GroupLayout.PREFERRED_SIZE, 95, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 347, Short.MAX_VALUE)
                        .addComponent(btnAddCustomer, javax.swing.GroupLayout.PREFERRED_SIZE, 95, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(36, 36, 36)
                        .addComponent(btnExport, javax.swing.GroupLayout.PREFERRED_SIZE, 89, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(pnlCustomerLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane2)))
                .addContainerGap())
        );
        pnlCustomerLayout.setVerticalGroup(
            pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlCustomerLayout.createSequentialGroup()
                .addGap(26, 26, 26)
                .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtSearch, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnSearch, javax.swing.GroupLayout.DEFAULT_SIZE, 34, Short.MAX_VALUE)
                    .addComponent(btnAddCustomer, javax.swing.GroupLayout.DEFAULT_SIZE, 34, Short.MAX_VALUE)
                    .addComponent(btnExport, javax.swing.GroupLayout.DEFAULT_SIZE, 34, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 476, Short.MAX_VALUE)
                .addGap(24, 24, 24))
        );

        scpPanel.setViewportView(pnlCustomer);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(scpPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 1012, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(scpPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 567, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btnAddCustomerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddCustomerActionPerformed
        AddCustomerFrame addCustomer = new AddCustomerFrame();
        addCustomer.setResizable(false);
        addCustomer.setLocationRelativeTo(null);
        addCustomer.setMinimumSize(null);
        addCustomer.setVisible(true);
    }//GEN-LAST:event_btnAddCustomerActionPerformed

    private void btnSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSearchActionPerformed
        if (txtSearch.getText().equals("")) {
            JOptionPane.showMessageDialog(null, "ข้อมูลไม่ถูกต้อง กรุณาลองใหม่อีกครั้ง");
        } else {
            Customer customer =cusService.getCustomersTel(txtSearch.getText());
            JOptionPane.showMessageDialog(null,"ข้อมูลของผู้ใช้เบอร์โทรนี้คือ\n" + customer);
            txtSearch.setText("");
        }
    }//GEN-LAST:event_btnSearchActionPerformed

    private void btnExportActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnExportActionPerformed
       if (tblCustomer.getRowCount() > 0) {
            MessageFormat header = new MessageFormat("ข้อมูลลูกค้า ");
            MessageFormat footer = new MessageFormat("หน้าที่ {0, number, integer}");

            try {
                tblCustomer.print(JTable.PrintMode.FIT_WIDTH, header, footer);
                cusModel.setRowCount(0);
//                setTotal();
            } catch (java.awt.print.PrinterException e) {
                JOptionPane.showMessageDialog(null, "ไม่สามารถพิมพ์รายการได้ เนื่องจากไม่พบเครื่องพิมพ์", "ไม่พบเครื่องพิมพ์", JOptionPane.INFORMATION_MESSAGE);
            }
        } else {
            JOptionPane.showMessageDialog(null, "ไม่สามารถพิมพ์รายการได้ เนื่องจากรายการยังว่างอยู่", "ไม่สามารถพิมพ์รายการได้", JOptionPane.INFORMATION_MESSAGE);
        }
    }//GEN-LAST:event_btnExportActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddCustomer;
    private javax.swing.JButton btnExport;
    private javax.swing.JButton btnSearch;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JPanel pnlCustomer;
    private javax.swing.JScrollPane scpPanel;
    private javax.swing.JTable tblCustomer;
    private javax.swing.JTextField txtSearch;
    // End of variables declaration//GEN-END:variables
}
